﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using DisqueRango;

namespace TrabLp
{
    class Arquivo
    {
        public DiskRango lerArquivo(string pathEntregador, string pathItensCardapio)
        {
            DiskRango diskRango = new DiskRango();
            try
            {
                StreamReader sr = new StreamReader(pathEntregador);
                int count = 0;
                while (sr.Peek() >= 0)
                {

                    //Lendo a linha
                    string[] linha = sr.ReadLine().Split(';');

                    //Vai servir mesmo só da segunda linha em diante
                    if (count != 0)
                    {
                        //Criando o objeto entregador
                        Entregador entregador = new Entregador(linha[0], linha[1]);

                        //Adicionando a lista de entregadores do diskRango
                        diskRango.adicionarEntregador(entregador);
                    }
                    count++;
                }
                //Ordena os entregadores por Ordem Alfabética das Placas e seta o primeiro como pronto.
                diskRango.ListaEntregadores = diskRango.ListaEntregadores.OrderBy(c => c.Placa).ToList();
                diskRango.ListaEntregadores[0].Presente = true;

                sr.Close();




                StreamReader sr2 = new StreamReader(pathItensCardapio);

                {

                    int count2 = 0;
                    while (sr2.Peek() >= 0)
                    {
                        string[] linha = sr2.ReadLine().Split(';');
                        if (count2 != 0)
                        {
                            //Criando o objeto itemCardapio

                            //Vendo se eh refeicao
                            if (linha[1].CompareTo("R") == 0)
                            {
                                bool boleano = false;
                                if (linha[4].CompareTo("x") == 0) { boleano = true; }

                                Refeicao refeicao = new Refeicao(Convert.ToInt32(linha[0]), linha[2], Convert.ToDouble(linha[3]), boleano);
                                diskRango.Cardapio.ItensCardapio.Add(refeicao);
                            }
                            //Vendo se eh bebida
                            if (linha[1] == "B")
                            {
                                Bebida bebida = new Bebida(Convert.ToInt32(linha[0]), linha[2], Convert.ToDouble(linha[3]), Convert.ToDouble(linha[5]));
                                diskRango.Cardapio.ItensCardapio.Add(bebida);
                            }
                            //Vendo se eh sobremesa
                            if (linha[1] == "S")
                            {
                                Sobremesa sobremesa = new Sobremesa(Convert.ToInt32(linha[0]), linha[2], Convert.ToDouble(linha[3]));
                                diskRango.Cardapio.ItensCardapio.Add(sobremesa);
                            }


                        }
                        count2++;
                    }
                    sr2.Close();
                }
            }

            catch (Exception e)
            {
                Console.WriteLine("The process failed: {0}", e.ToString());
            }
            return diskRango;
        }
        public DiskRango escreveArquivo(DiskRango diskRango)
        {
            string fileName = "saidaentregadores.txt";
            //string fileName2 = "saidarefeicao.txt";

            /*StreamWriter wr = new StreamWriter(fileName2);
            for (int i = 0; i < diskRango.Cardapio.ItensCardapio.Count; i++)
            {
                wr.Write(diskRango.Cardapio.ItensCardapio[i].Codigo);
                wr.Write("-");
                wr.Write(diskRango.Cardapio.ItensCardapio[i].Nome);
                wr.Write("-");
                wr.WriteLine(diskRango.Cardapio.ItensCardapio[i].Preco);
            }
            wr.Close();*/

            StreamWriter wr2 = new StreamWriter(fileName);
            diskRango.ListaEntregadores = diskRango.ListaEntregadores.OrderBy(c => c.Nome).ToList();
            wr2.WriteLine("Entregador;Qtd.entregas;Valor total;Comissão");
            for (int i = 0; i < diskRango.ListaEntregadores.Count; i++)
            {
                wr2.Write(diskRango.ListaEntregadores[i].Nome);
                wr2.Write(";");
                wr2.Write(diskRango.ListaEntregadores[i].Entregas);
                wr2.Write(";");
                wr2.Write(diskRango.ListaEntregadores[i].Comissao / 0.05);
                wr2.Write(";");
                wr2.WriteLine(diskRango.ListaEntregadores[i].Comissao);
            }
            wr2.Close();

            return diskRango;
        }
    }
}
